Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision 6613ec959229c059f4df050384fc4621ea87dcc0)
+++ src/tesselation.cpp	(revision 29955407eeb6f84cd775a755f6e7b4d9beba3aa5)
@@ -28,5 +28,5 @@
 {
   Info FunctionInfo(__func__);
-  Log() << Verbose(1) << "Adding noname." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Adding noname." << endl);
 }
 ;
@@ -39,5 +39,5 @@
 {
   Info FunctionInfo(__func__);
-  Log() << Verbose(1) << "Adding Node " << *Walker << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Adding Node " << *Walker << endl);
 }
 ;
@@ -63,5 +63,5 @@
 {
   Info FunctionInfo(__func__);
-  Log() << Verbose(1) << "Adding " << *this << " to line " << *line << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Adding " << *this << " to line " << *line << "." << endl);
   if (line->endpoints[0] == this) {
     lines.insert(LinePair(line->endpoints[1]->Nr, line));
@@ -115,5 +115,5 @@
   skipped = false;
   // clear triangles list
-  Log() << Verbose(0) << "New Line with endpoints " << *this << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "New Line with endpoints " << *this << "." << endl);
 }
 ;
@@ -138,5 +138,5 @@
   skipped = false;
   // clear triangles list
-  Log() << Verbose(0) << "New Line with endpoints " << *this << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "New Line with endpoints " << *this << "." << endl);
 }
 ;
@@ -196,5 +196,5 @@
 {
   Info FunctionInfo(__func__);
-  Log() << Verbose(0) << "Add " << triangle->Nr << " to line " << *this << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Add " << triangle->Nr << " to line " << *this << "." << endl);
   triangles.insert(TrianglePair(triangle->Nr, triangle));
 }
@@ -270,5 +270,5 @@
   //Log() << Verbose(0) << "INFO: BaselineNormal is " << BaseLineNormal << "." << endl;
   if (NormalCheck.NormSquared() < MYEPSILON) {
-    Log() << Verbose(0) << "ACCEPT: Normalvectors of both triangles are the same: convex." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "ACCEPT: Normalvectors of both triangles are the same: convex." << endl);
     return true;
   }
@@ -276,8 +276,8 @@
   double angle = GetAngle(helper[0], helper[1], BaseLineNormal);
   if ((angle - M_PI) > -MYEPSILON) {
-    Log() << Verbose(0) << "ACCEPT: Angle is greater than pi: convex." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "ACCEPT: Angle is greater than pi: convex." << endl);
     return true;
   } else {
-    Log() << Verbose(0) << "REJECT: Angle is less than pi: concave." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "REJECT: Angle is less than pi: concave." << endl);
     return false;
   }
@@ -364,8 +364,8 @@
   // set endpoints
   int Counter = 0;
-  Log() << Verbose(0) << "New triangle " << Nr << " with end points: " << endl;
+  DoLog(0) && (Log() << Verbose(0) << "New triangle " << Nr << " with end points: " << endl);
   for (PointMap::iterator runner = OrderMap.begin(); runner != OrderMap.end(); runner++) {
     endpoints[Counter] = runner->second;
-    Log() << Verbose(0) << " " << *endpoints[Counter] << endl;
+    DoLog(0) && (Log() << Verbose(0) << " " << *endpoints[Counter] << endl);
     Counter++;
   }
@@ -413,5 +413,5 @@
   if (NormalVector.ScalarProduct(&OtherVector) > 0.)
     NormalVector.Scale(-1.);
-  Log() << Verbose(1) << "Normal Vector is " << NormalVector << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Normal Vector is " << NormalVector << "." << endl);
 }
 ;
@@ -440,16 +440,16 @@
   }
 
-  Log() << Verbose(1) << "INFO: Triangle is " << *this << "." << endl;
-  Log() << Verbose(1) << "INFO: Line is from " << *MolCenter << " to " << *x << "." << endl;
-  Log() << Verbose(1) << "INFO: Intersection is " << *Intersection << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Triangle is " << *this << "." << endl);
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Line is from " << *MolCenter << " to " << *x << "." << endl);
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Intersection is " << *Intersection << "." << endl);
 
   if (Intersection->DistanceSquared(endpoints[0]->node->node) < MYEPSILON) {
-    Log() << Verbose(1) << "Intersection coindices with first endpoint." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Intersection coindices with first endpoint." << endl);
     return true;
   } else if (Intersection->DistanceSquared(endpoints[1]->node->node) < MYEPSILON) {
-    Log() << Verbose(1) << "Intersection coindices with second endpoint." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Intersection coindices with second endpoint." << endl);
     return true;
   } else if (Intersection->DistanceSquared(endpoints[2]->node->node) < MYEPSILON) {
-    Log() << Verbose(1) << "Intersection coindices with third endpoint." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Intersection coindices with third endpoint." << endl);
     return true;
   }
@@ -462,7 +462,7 @@
       CrossPoint.SubtractVector(endpoints[i % 3]->node->node); // cross point was returned as absolute vector
       const double s = CrossPoint.ScalarProduct(&helper) / helper.NormSquared();
-      Log() << Verbose(1) << "INFO: Factor s is " << s << "." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "INFO: Factor s is " << s << "." << endl);
       if ((s < -MYEPSILON) || ((s - 1.) > MYEPSILON)) {
-        Log() << Verbose(1) << "INFO: Crosspoint " << CrossPoint << "outside of triangle." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "INFO: Crosspoint " << CrossPoint << "outside of triangle." << endl);
         i = 4;
         break;
@@ -473,8 +473,8 @@
   } while (i < 3);
   if (i == 3) {
-    Log() << Verbose(1) << "INFO: Crosspoint " << CrossPoint << " inside of triangle." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Crosspoint " << CrossPoint << " inside of triangle." << endl);
     return true;
   } else {
-    Log() << Verbose(1) << "INFO: Crosspoint " << CrossPoint << " outside of triangle." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Crosspoint " << CrossPoint << " outside of triangle." << endl);
     return false;
   }
@@ -500,5 +500,5 @@
 
   // 1. get intersection with plane
-  Log() << Verbose(1) << "INFO: Looking for closest point of triangle " << *this << " to " << *x << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Looking for closest point of triangle " << *this << " to " << *x << "." << endl);
   GetCenter(&Direction);
   if (!ClosestPoint->GetIntersectionWithPlane(&NormalVector, endpoints[0]->node->node, x, &Direction)) {
@@ -513,7 +513,7 @@
   InPlane.AddVector(ClosestPoint);
 
-  Log() << Verbose(2) << "INFO: Triangle is " << *this << "." << endl;
-  Log() << Verbose(2) << "INFO: Line is from " << Direction << " to " << *x << "." << endl;
-  Log() << Verbose(2) << "INFO: In-plane part is " << InPlane << "." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "INFO: Triangle is " << *this << "." << endl);
+  DoLog(2) && (Log() << Verbose(2) << "INFO: Line is from " << Direction << " to " << *x << "." << endl);
+  DoLog(2) && (Log() << Verbose(2) << "INFO: In-plane part is " << InPlane << "." << endl);
 
   // Calculate cross point between one baseline and the desired point such that distance is shortest
@@ -533,8 +533,8 @@
     CrossPoint[i].SubtractVector(endpoints[i % 3]->node->node); // cross point was returned as absolute vector
     const double s = CrossPoint[i].ScalarProduct(&Direction) / Direction.NormSquared();
-    Log() << Verbose(2) << "INFO: Factor s is " << s << "." << endl;
+    DoLog(2) && (Log() << Verbose(2) << "INFO: Factor s is " << s << "." << endl);
     if ((s >= -MYEPSILON) && ((s - 1.) <= MYEPSILON)) {
       CrossPoint[i].AddVector(endpoints[i % 3]->node->node); // make cross point absolute again
-      Log() << Verbose(2) << "INFO: Crosspoint is " << CrossPoint[i] << ", intersecting BoundaryLine between " << *endpoints[i % 3]->node->node << " and " << *endpoints[(i + 1) % 3]->node->node << "." << endl;
+      DoLog(2) && (Log() << Verbose(2) << "INFO: Crosspoint is " << CrossPoint[i] << ", intersecting BoundaryLine between " << *endpoints[i % 3]->node->node << " and " << *endpoints[(i + 1) % 3]->node->node << "." << endl);
       const double distance = CrossPoint[i].DistanceSquared(x);
       if ((ShortestDistance < 0.) || (ShortestDistance > distance)) {
@@ -565,5 +565,5 @@
     }
   }
-  Log() << Verbose(1) << "INFO: Closest Point is " << *ClosestPoint << " with shortest squared distance is " << ShortestDistance << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Closest Point is " << *ClosestPoint << " with shortest squared distance is " << ShortestDistance << "." << endl);
   return ShortestDistance;
 }
@@ -619,5 +619,5 @@
 {
   Info FunctionInfo(__func__);
-  Log() << Verbose(1) << "INFO: Checking " << Points[0] << "," << Points[1] << "," << Points[2] << " against " << endpoints[0] << "," << endpoints[1] << "," << endpoints[2] << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Checking " << Points[0] << "," << Points[1] << "," << Points[2] << " against " << endpoints[0] << "," << endpoints[1] << "," << endpoints[2] << "." << endl);
   return (((endpoints[0] == Points[0]) || (endpoints[0] == Points[1]) || (endpoints[0] == Points[2])) && ((endpoints[1] == Points[0]) || (endpoints[1] == Points[1]) || (endpoints[1] == Points[2])) && ((endpoints[2] == Points[0]) || (endpoints[2] == Points[1]) || (endpoints[2] == Points[2])
 
@@ -668,5 +668,5 @@
     center->AddVector(endpoints[i]->node->node);
   center->Scale(1. / 3.);
-  Log() << Verbose(1) << "INFO: Center is at " << *center << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Center is at " << *center << "." << endl);
 }
 
@@ -703,5 +703,5 @@
   Info FunctionInfo(__func__);
   endpoints.clear();
-  Log() << Verbose(1) << "Erasing polygon Nr." << Nr << " itself." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Erasing polygon Nr." << Nr << " itself." << endl);
 }
 ;
@@ -742,5 +742,5 @@
   if (TotalNormal->ScalarProduct(&OtherVector) > 0.)
     TotalNormal->Scale(-1.);
-  Log() << Verbose(1) << "Normal Vector is " << *TotalNormal << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Normal Vector is " << *TotalNormal << "." << endl);
 
   return TotalNormal;
@@ -762,5 +762,5 @@
   }
   center->Scale(1. / (double) counter);
-  Log() << Verbose(1) << "Center is at " << *center << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Center is at " << *center << "." << endl);
 }
 
@@ -795,11 +795,11 @@
   Info FunctionInfo(__func__);
   for (PointSet::const_iterator Runner = endpoints.begin(); Runner != endpoints.end(); Runner++) {
-    Log() << Verbose(0) << "Checking against " << **Runner << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Checking against " << **Runner << endl);
     if (point == (*Runner)) {
-      Log() << Verbose(0) << " Contained." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " Contained." << endl);
       return true;
     }
   }
-  Log() << Verbose(0) << " Not contained." << endl;
+  DoLog(0) && (Log() << Verbose(0) << " Not contained." << endl);
   return false;
 }
@@ -815,8 +815,8 @@
   for (PointSet::const_iterator Runner = endpoints.begin(); Runner != endpoints.end(); Runner++)
     if (point == (*Runner)->node) {
-      Log() << Verbose(0) << " Contained." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " Contained." << endl);
       return true;
     }
-  Log() << Verbose(0) << " Not contained." << endl;
+  DoLog(0) && (Log() << Verbose(0) << " Not contained." << endl);
   return false;
 }
@@ -832,7 +832,7 @@
   Info FunctionInfo(__func__);
   int counter = 0;
-  Log() << Verbose(1) << "Polygon is " << *this << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Polygon is " << *this << endl);
   for (int i = 0; i < dim; i++) {
-    Log() << Verbose(1) << " Testing endpoint " << *Points[i] << endl;
+    DoLog(1) && (Log() << Verbose(1) << " Testing endpoint " << *Points[i] << endl);
     if (ContainsBoundaryPoint(Points[i])) {
       counter++;
@@ -855,7 +855,7 @@
   Info FunctionInfo(__func__);
   size_t counter = 0;
-  Log() << Verbose(1) << "Polygon is " << *this << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Polygon is " << *this << endl);
   for (PointSet::const_iterator Runner = endpoints.begin(); Runner != endpoints.end(); Runner++) {
-    Log() << Verbose(1) << " Testing endpoint " << **Runner << endl;
+    DoLog(1) && (Log() << Verbose(1) << " Testing endpoint " << **Runner << endl);
     if (ContainsBoundaryPoint(*Runner))
       counter++;
@@ -895,9 +895,9 @@
           Tester = triangles->insert(Sprinter->second);
           if (Tester.second)
-            Log() << Verbose(0) << "Adding triangle " << *(Sprinter->second) << endl;
+            DoLog(0) && (Log() << Verbose(0) << "Adding triangle " << *(Sprinter->second) << endl);
         }
       }
 
-  Log() << Verbose(1) << "The Polygon of " << endpoints.size() << " endpoints has " << triangles->size() << " unique triangles in total." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "The Polygon of " << endpoints.size() << " endpoints has " << triangles->size() << " unique triangles in total." << endl);
   return triangles;
 }
@@ -914,10 +914,10 @@
   if (line == NULL)
     return false;
-  Log() << Verbose(1) << "Filling polygon from line " << *line << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Filling polygon from line " << *line << endl);
   for (TriangleMap::const_iterator Runner = line->triangles.begin(); Runner != line->triangles.end(); Runner++) {
     for (int i = 0; i < 3; i++) {
       Tester = endpoints.insert((Runner->second)->endpoints[i]);
       if (Tester.second)
-        Log() << Verbose(1) << "  Inserting endpoint " << *((Runner->second)->endpoints[i]) << endl;
+        DoLog(1) && (Log() << Verbose(1) << "  Inserting endpoint " << *((Runner->second)->endpoints[i]) << endl);
     }
   }
@@ -1071,5 +1071,5 @@
         return false;
       } else {
-        Log() << Verbose(1) << "Candidate " << *Walker << " is inside by " << distance << "." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Candidate " << *Walker << " is inside by " << distance << "." << endl);
       }
     }
@@ -1082,15 +1082,15 @@
     TesselPointList *ListofPoints = LC->GetPointsInsideSphere(RADIUS, (*VRunner));
 
-    Log() << Verbose(1) << "The following atoms are inside sphere at " << OtherOptCenter << ":" << endl;
+    DoLog(1) && (Log() << Verbose(1) << "The following atoms are inside sphere at " << OtherOptCenter << ":" << endl);
     for (TesselPointList::const_iterator Runner = ListofPoints->begin(); Runner != ListofPoints->end(); ++Runner)
-      Log() << Verbose(1) << "  " << *(*Runner) << " with distance " << (*Runner)->node->Distance(&OtherOptCenter) << "." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "  " << *(*Runner) << " with distance " << (*Runner)->node->Distance(&OtherOptCenter) << "." << endl);
 
     // remove baseline's endpoints and candidates
     for (int i = 0; i < 2; i++) {
-      Log() << Verbose(1) << "INFO: removing baseline tesselpoint " << *BaseLine->endpoints[i]->node << "." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "INFO: removing baseline tesselpoint " << *BaseLine->endpoints[i]->node << "." << endl);
       ListofPoints->remove(BaseLine->endpoints[i]->node);
     }
     for (TesselPointList::const_iterator Runner = pointlist.begin(); Runner != pointlist.end(); ++Runner) {
-      Log() << Verbose(1) << "INFO: removing candidate tesselpoint " << *(*Runner) << "." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "INFO: removing candidate tesselpoint " << *(*Runner) << "." << endl);
       ListofPoints->remove(*Runner);
     }
@@ -1106,8 +1106,8 @@
     // check with animate_sphere.tcl VMD script
     if (ThirdPoint != NULL) {
-      Log() << Verbose(1) << "Check by: animate_sphere 0 " << BaseLine->endpoints[0]->Nr + 1 << " " << BaseLine->endpoints[1]->Nr + 1 << " " << ThirdPoint->Nr + 1 << " " << RADIUS << " " << OldCenter.x[0] << " " << OldCenter.x[1] << " " << OldCenter.x[2] << " " << (*VRunner)->x[0] << " " << (*VRunner)->x[1] << " " << (*VRunner)->x[2] << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Check by: animate_sphere 0 " << BaseLine->endpoints[0]->Nr + 1 << " " << BaseLine->endpoints[1]->Nr + 1 << " " << ThirdPoint->Nr + 1 << " " << RADIUS << " " << OldCenter.x[0] << " " << OldCenter.x[1] << " " << OldCenter.x[2] << " " << (*VRunner)->x[0] << " " << (*VRunner)->x[1] << " " << (*VRunner)->x[2] << endl);
     } else {
-      Log() << Verbose(1) << "Check by: ... missing third point ..." << endl;
-      Log() << Verbose(1) << "Check by: animate_sphere 0 " << BaseLine->endpoints[0]->Nr + 1 << " " << BaseLine->endpoints[1]->Nr + 1 << " ??? " << RADIUS << " " << OldCenter.x[0] << " " << OldCenter.x[1] << " " << OldCenter.x[2] << " " << (*VRunner)->x[0] << " " << (*VRunner)->x[1] << " " << (*VRunner)->x[2] << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Check by: ... missing third point ..." << endl);
+      DoLog(1) && (Log() << Verbose(1) << "Check by: animate_sphere 0 " << BaseLine->endpoints[0]->Nr + 1 << " " << BaseLine->endpoints[1]->Nr + 1 << " ??? " << RADIUS << " " << OldCenter.x[0] << " " << OldCenter.x[1] << " " << OldCenter.x[2] << " " << (*VRunner)->x[0] << " " << (*VRunner)->x[1] << " " << (*VRunner)->x[2] << endl);
     }
   }
@@ -1157,5 +1157,5 @@
 {
   Info FunctionInfo(__func__);
-  Log() << Verbose(0) << "Free'ing TesselStruct ... " << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Free'ing TesselStruct ... " << endl);
   for (TriangleMap::iterator runner = TrianglesOnBoundary.begin(); runner != TrianglesOnBoundary.end(); runner++) {
     if (runner->second != NULL) {
@@ -1165,5 +1165,5 @@
       DoeLog(1) && (eLog() << Verbose(1) << "The triangle " << runner->first << " has already been free'd." << endl);
   }
-  Log() << Verbose(0) << "This envelope was written to file " << TriangleFilesWritten << " times(s)." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "This envelope was written to file " << TriangleFilesWritten << " times(s)." << endl);
 }
 ;
@@ -1319,5 +1319,5 @@
     // 3. construct plane vector
     PlaneVector.MakeNormalVector(A->second->node->node, baseline->second.first->second->node->node, baseline->second.second->second->node->node);
-    Log() << Verbose(2) << "Plane vector of candidate triangle is " << PlaneVector << endl;
+    DoLog(2) && (Log() << Verbose(2) << "Plane vector of candidate triangle is " << PlaneVector << endl);
     // 4. loop over all points
     double sign = 0.;
@@ -1333,13 +1333,13 @@
       if (fabs(distance) < 1e-4) // we need to have a small epsilon around 0 which is still ok
         continue;
-      Log() << Verbose(2) << "Projection of " << checker->second->node->Name << " yields distance of " << distance << "." << endl;
+      DoLog(2) && (Log() << Verbose(2) << "Projection of " << checker->second->node->Name << " yields distance of " << distance << "." << endl);
       tmp = distance / fabs(distance);
       // 4b. Any have different sign to than before? (i.e. would lie outside convex hull with this starting triangle)
       if ((sign != 0) && (tmp != sign)) {
         // 4c. If so, break 4. loop and continue with next candidate in 1. loop
-        Log() << Verbose(2) << "Current candidates: " << A->second->node->Name << "," << baseline->second.first->second->node->Name << "," << baseline->second.second->second->node->Name << " leaves " << checker->second->node->Name << " outside the convex hull." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Current candidates: " << A->second->node->Name << "," << baseline->second.first->second->node->Name << "," << baseline->second.second->second->node->Name << " leaves " << checker->second->node->Name << " outside the convex hull." << endl);
         break;
       } else { // note the sign for later
-        Log() << Verbose(2) << "Current candidates: " << A->second->node->Name << "," << baseline->second.first->second->node->Name << "," << baseline->second.second->second->node->Name << " leave " << checker->second->node->Name << " inside the convex hull." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Current candidates: " << A->second->node->Name << "," << baseline->second.first->second->node->Name << "," << baseline->second.second->second->node->Name << " leave " << checker->second->node->Name << " inside the convex hull." << endl);
         sign = tmp;
       }
@@ -1361,5 +1361,5 @@
     // 5. come this far, all on same side? Then break 1. loop and construct triangle
     if (checker == PointsOnBoundary.end()) {
-      Log() << Verbose(2) << "Looks like we have a candidate!" << endl;
+      DoLog(2) && (Log() << Verbose(2) << "Looks like we have a candidate!" << endl);
       break;
     }
@@ -1385,5 +1385,5 @@
     }
 
-    Log() << Verbose(1) << "Starting triangle is " << *BTS << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Starting triangle is " << *BTS << "." << endl);
   } else {
     DoeLog(0) && (eLog() << Verbose(0) << "No starting triangle found." << endl);
@@ -1426,9 +1426,9 @@
         // get peak point with respect to this base line's only triangle
         BTS = baseline->second->triangles.begin()->second; // there is only one triangle so far
-        Log() << Verbose(0) << "Current baseline is between " << *(baseline->second) << "." << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Current baseline is between " << *(baseline->second) << "." << endl);
         for (int i = 0; i < 3; i++)
           if ((BTS->endpoints[i] != baseline->second->endpoints[0]) && (BTS->endpoints[i] != baseline->second->endpoints[1]))
             peak = BTS->endpoints[i];
-        Log() << Verbose(1) << " and has peak " << *peak << "." << endl;
+        DoLog(1) && (Log() << Verbose(1) << " and has peak " << *peak << "." << endl);
 
         // prepare some auxiliary vectors
@@ -1445,5 +1445,5 @@
           CenterVector.AddVector(BTS->endpoints[i]->node->node);
         CenterVector.Scale(1. / 3.);
-        Log() << Verbose(2) << "CenterVector of base triangle is " << CenterVector << endl;
+        DoLog(2) && (Log() << Verbose(2) << "CenterVector of base triangle is " << CenterVector << endl);
 
         // normal vector of triangle
@@ -1452,5 +1452,5 @@
         BTS->GetNormalVector(NormalVector);
         NormalVector.CopyVector(&BTS->NormalVector);
-        Log() << Verbose(2) << "NormalVector of base triangle is " << NormalVector << endl;
+        DoLog(2) && (Log() << Verbose(2) << "NormalVector of base triangle is " << NormalVector << endl);
 
         // vector in propagation direction (out of triangle)
@@ -1462,5 +1462,5 @@
         if (PropagationVector.ScalarProduct(&TempVector) > 0) // make sure normal propagation vector points outward from baseline
           PropagationVector.Scale(-1.);
-        Log() << Verbose(2) << "PropagationVector of base triangle is " << PropagationVector << endl;
+        DoLog(2) && (Log() << Verbose(2) << "PropagationVector of base triangle is " << PropagationVector << endl);
         winner = PointsOnBoundary.end();
 
@@ -1468,5 +1468,5 @@
         for (PointMap::iterator target = PointsOnBoundary.begin(); target != PointsOnBoundary.end(); target++) {
           if ((target->second != baseline->second->endpoints[0]) && (target->second != baseline->second->endpoints[1])) { // don't take the same endpoints
-            Log() << Verbose(1) << "Target point is " << *(target->second) << ":" << endl;
+            DoLog(1) && (Log() << Verbose(1) << "Target point is " << *(target->second) << ":" << endl);
 
             // first check direction, so that triangles don't intersect
@@ -1475,10 +1475,10 @@
             VirtualNormalVector.ProjectOntoPlane(&NormalVector);
             TempAngle = VirtualNormalVector.Angle(&PropagationVector);
-            Log() << Verbose(2) << "VirtualNormalVector is " << VirtualNormalVector << " and PropagationVector is " << PropagationVector << "." << endl;
+            DoLog(2) && (Log() << Verbose(2) << "VirtualNormalVector is " << VirtualNormalVector << " and PropagationVector is " << PropagationVector << "." << endl);
             if (TempAngle > (M_PI / 2.)) { // no bends bigger than Pi/2 (90 degrees)
-              Log() << Verbose(2) << "Angle on triangle plane between propagation direction and base line to " << *(target->second) << " is " << TempAngle << ", bad direction!" << endl;
+              DoLog(2) && (Log() << Verbose(2) << "Angle on triangle plane between propagation direction and base line to " << *(target->second) << " is " << TempAngle << ", bad direction!" << endl);
               continue;
             } else
-              Log() << Verbose(2) << "Angle on triangle plane between propagation direction and base line to " << *(target->second) << " is " << TempAngle << ", good direction!" << endl;
+              DoLog(2) && (Log() << Verbose(2) << "Angle on triangle plane between propagation direction and base line to " << *(target->second) << " is " << TempAngle << ", good direction!" << endl);
 
             // check first and second endpoint (if any connecting line goes to target has at least not more than 1 triangle)
@@ -1486,9 +1486,9 @@
             LineChecker[1] = baseline->second->endpoints[1]->lines.find(target->first);
             if (((LineChecker[0] != baseline->second->endpoints[0]->lines.end()) && (LineChecker[0]->second->triangles.size() == 2))) {
-              Log() << Verbose(2) << *(baseline->second->endpoints[0]) << " has line " << *(LineChecker[0]->second) << " to " << *(target->second) << " as endpoint with " << LineChecker[0]->second->triangles.size() << " triangles." << endl;
+              DoLog(2) && (Log() << Verbose(2) << *(baseline->second->endpoints[0]) << " has line " << *(LineChecker[0]->second) << " to " << *(target->second) << " as endpoint with " << LineChecker[0]->second->triangles.size() << " triangles." << endl);
               continue;
             }
             if (((LineChecker[1] != baseline->second->endpoints[1]->lines.end()) && (LineChecker[1]->second->triangles.size() == 2))) {
-              Log() << Verbose(2) << *(baseline->second->endpoints[1]) << " has line " << *(LineChecker[1]->second) << " to " << *(target->second) << " as endpoint with " << LineChecker[1]->second->triangles.size() << " triangles." << endl;
+              DoLog(2) && (Log() << Verbose(2) << *(baseline->second->endpoints[1]) << " has line " << *(LineChecker[1]->second) << " to " << *(target->second) << " as endpoint with " << LineChecker[1]->second->triangles.size() << " triangles." << endl);
               continue;
             }
@@ -1496,5 +1496,5 @@
             // check whether the envisaged triangle does not already exist (if both lines exist and have same endpoint)
             if ((((LineChecker[0] != baseline->second->endpoints[0]->lines.end()) && (LineChecker[1] != baseline->second->endpoints[1]->lines.end()) && (GetCommonEndpoint(LineChecker[0]->second, LineChecker[1]->second) == peak)))) {
-              Log() << Verbose(4) << "Current target is peak!" << endl;
+              DoLog(4) && (Log() << Verbose(4) << "Current target is peak!" << endl);
               continue;
             }
@@ -1507,5 +1507,5 @@
             helper.ProjectOntoPlane(&TempVector);
             if (fabs(helper.NormSquared()) < MYEPSILON) {
-              Log() << Verbose(2) << "Chosen set of vectors is linear dependent." << endl;
+              DoLog(2) && (Log() << Verbose(2) << "Chosen set of vectors is linear dependent." << endl);
               continue;
             }
@@ -1524,9 +1524,9 @@
             // calculate angle
             TempAngle = NormalVector.Angle(&VirtualNormalVector);
-            Log() << Verbose(2) << "NormalVector is " << VirtualNormalVector << " and the angle is " << TempAngle << "." << endl;
+            DoLog(2) && (Log() << Verbose(2) << "NormalVector is " << VirtualNormalVector << " and the angle is " << TempAngle << "." << endl);
             if ((SmallestAngle - TempAngle) > MYEPSILON) { // set to new possible winner
               SmallestAngle = TempAngle;
               winner = target;
-              Log() << Verbose(2) << "New winner " << *winner->second->node << " due to smaller angle between normal vectors." << endl;
+              DoLog(2) && (Log() << Verbose(2) << "New winner " << *winner->second->node << " due to smaller angle between normal vectors." << endl);
             } else if (fabs(SmallestAngle - TempAngle) < MYEPSILON) { // check the angle to propagation, both possible targets are in one plane! (their normals have same angle)
               // hence, check the angles to some normal direction from our base line but in this common plane of both targets...
@@ -1546,9 +1546,9 @@
                 SmallestAngle = TempAngle;
                 winner = target;
-                Log() << Verbose(2) << "New winner " << *winner->second->node << " due to smaller angle " << TempAngle << " to propagation direction." << endl;
+                DoLog(2) && (Log() << Verbose(2) << "New winner " << *winner->second->node << " due to smaller angle " << TempAngle << " to propagation direction." << endl);
               } else
-                Log() << Verbose(2) << "Keeping old winner " << *winner->second->node << " due to smaller angle to propagation direction." << endl;
+                DoLog(2) && (Log() << Verbose(2) << "Keeping old winner " << *winner->second->node << " due to smaller angle to propagation direction." << endl);
             } else
-              Log() << Verbose(2) << "Keeping old winner " << *winner->second->node << " due to smaller angle between normal vectors." << endl;
+              DoLog(2) && (Log() << Verbose(2) << "Keeping old winner " << *winner->second->node << " due to smaller angle between normal vectors." << endl);
           }
         } // end of loop over all boundary points
@@ -1556,5 +1556,5 @@
         // 5b. The point of the above whose triangle has the greatest angle with the triangle the current line belongs to (it only belongs to one, remember!): New triangle
         if (winner != PointsOnBoundary.end()) {
-          Log() << Verbose(0) << "Winning target point is " << *(winner->second) << " with angle " << SmallestAngle << "." << endl;
+          DoLog(0) && (Log() << Verbose(0) << "Winning target point is " << *(winner->second) << " with angle " << SmallestAngle << "." << endl);
           // create the lins of not yet present
           BLS[0] = baseline->second;
@@ -1591,5 +1591,5 @@
         // 5d. If the set of lines is not yet empty, go to 5. and continue
       } else
-        Log() << Verbose(0) << "Baseline candidate " << *(baseline->second) << " has a triangle count of " << baseline->second->triangles.size() << "." << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Baseline candidate " << *(baseline->second) << " has a triangle count of " << baseline->second->triangles.size() << "." << endl);
   } while (flag);
 
